#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include "common.h"

// Υᥤ󥦥ɥ
extern GtkWidget *main_window;

/////////////////////////////////////////////////////////////////////
// åܥå

static int res;
static GtkWidget *dialog;

static void pressed(GtkWidget *widget, gint no)
{
  res  =  no;
  gtk_widget_destroy(dialog);
  gtk_main_quit();
}

/*
  åܥåɽ
  msg : å
  title : ȥ
  buttonstr : ܥʸ(ʣΥܥϡäǶڤ)
  default_btn : ǥեȤΥܥֹ()
   줿ܥֹ()
*/
int msgbox(const char *msg, const char *title, const char *buttonstr, int default_btn)
{
  GtkWidget *label;
  GtkWidget *button;
  char btnstr[1000], msgstr[1000]; 
  int i, no;

  // 
  dialog = gtk_dialog_new();
  
  // ٥
  gtk_signal_connect (GTK_OBJECT (dialog), "delete_event",
		      GTK_SIGNAL_FUNC (pressed), (gpointer)-1);
  gtk_signal_connect (GTK_OBJECT (dialog), "destroy",
		      GTK_SIGNAL_FUNC (gtk_main_quit), NULL);

  // ɽ
  gtk_widget_show(dialog);

  // ȥɽ
  gtk_window_set_title(GTK_WINDOW(dialog), title);

  // åɽ
  sprintf(msgstr,"  %s  ", msg);
  label = gtk_label_new(msgstr);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
                     label, TRUE,TRUE,8);

  // ܥ
  no  = 0;
  for (i=0;; buttonstr++) {
    if (*buttonstr=='|' || *buttonstr==0) {
      btnstr[i] = 0;
      button = gtk_button_new_with_label(btnstr);
      gtk_widget_show(button);
      gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), 
			 button, TRUE,TRUE,0);
      gtk_signal_connect(GTK_OBJECT(button), "clicked",
			 GTK_SIGNAL_FUNC(pressed), (gpointer)no);
      GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      if (no == default_btn) {
	gtk_widget_grab_default (button);
      }

      no++;

      if (*buttonstr==0) {
	break;
      } else {
	i=0;
	continue;
      }
    }
    btnstr[i++] = *buttonstr;
  }
  
  // åܥåΥץ饤ƥ
  if (main_window != NULL) {
    gtk_window_set_modal (GTK_WINDOW(dialog), TRUE);
    gtk_window_set_transient_for (GTK_WINDOW (dialog),
				  GTK_WINDOW (main_window));
  }

  gtk_main();
  
  return res;
}



/////////////////////////////////////////////////////////////////////
// ե

static GtkWidget *dlg_file;
int file_dialog_res;
static char filename[1000];


static void file_cancel(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(dlg_file);
  gtk_main_quit();
}

static void file_ok(GtkWidget *widget, gpointer data)
{
  file_dialog_res = TRUE;
  strcpy(filename, 
	 gtk_file_selection_get_filename (GTK_FILE_SELECTION (dlg_file)));
  gtk_widget_destroy(dlg_file);
  gtk_main_quit();
}


/*
  եɽ
  res : ե̾Ǽݥ
  title : Υȥ
  default_fn : ǥեȤΥե̾(ꤷʤNULL)
   TRUE:򤵤줿 FALSE:򤵤ʤä
*/
int file_dialog(char *res, const char *title, const char *default_fn)
{
  file_dialog_res = FALSE;
  dlg_file = gtk_file_selection_new (title);
  if (default_fn) {
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(dlg_file),
				     default_fn);
  }

  // ץ饤ƥ
  if (main_window != NULL) {
    gtk_window_set_modal (GTK_WINDOW(dlg_file), TRUE);
    gtk_window_set_transient_for (GTK_WINDOW (dlg_file),
				  GTK_WINDOW (main_window));
  }

  // OKܥ󥷥ʥ
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (dlg_file)->ok_button),
		      "clicked", 
		      (GtkSignalFunc)file_ok, 
		      dlg_file );
    
  // CANCELܥ󥷥ʥ
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (dlg_file)->cancel_button),
			     "clicked", 
			     GTK_SIGNAL_FUNC (file_cancel),
			     GTK_OBJECT (dlg_file));
  
  gtk_widget_show(dlg_file);
  gtk_main();

  if (file_dialog_res == TRUE) {
    strcpy(res, filename);
  }

  return file_dialog_res;
}

